<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Api_Discipline extends Controller_Api_Handler {

    const ERROR_ID_IS_INCORRECT = 'id is incorrect';

    # GET: /api/discipline/723
    public function action_index() {
        $id = $this->request->param('id', 0);

        if ($id <= 0)
            throw new InvalidArgumentException(self::ERROR_ID_IS_INCORRECT);

        return ['name' => 'hello']; #Model_Discipline::load($id);
    }

    # POST: /api/discipline/create
    public function action_create() {
        $discipline = Model_Discipline::make()
            ->author  ($this->user['TeacherID'])
            ->faculty ($this->post['facultyID'])
            ->subject ($this->post['subjectID'])
            ->grade   ($this->post['gradeID'])
            ->lectures($this->post['lectures'])
            ->practice($this->post['practice'])
            ->labs    ($this->post['labs'])
            ->type    ($this->post['type'])
            ->create();

        if ($this->post['bonus'] == "true")
            Model_Map::AddModuleBonus($this->user['TeacherID'], $discipline->ID);

        return ['ID' => $discipline->ID];
    }

    # PUT: /api/discipline/update/723
    public function action_update() {
        $id = $this->request->param('id', 0);

        if ($id <= 0)
            throw new InvalidArgumentException(self::ERROR_ID_IS_INCORRECT);

        throw new LogicException('Not implemented yet');
    }

    # DELETE: /api/discipline/delete/723
    public function action_delete() {
        $id = $this->request->param('id', 0);

        if ($id <= 0)
            throw new InvalidArgumentException(self::ERROR_ID_IS_INCORRECT);

        throw new LogicException('Not implemented yet');
    }
}